\chapter{Future Work and Recommendations}


\section{Short Term Recommendations regarding Whisker}
The following list reflects recommendations for the short-term development of Whisker:

\begin{itemize}
  \item When the test developers write test code measuring time or working with time based control structures, the  \texttt{getTotalTimeElapsed} and \texttt{getRunTimeElapsed} should be used to handle time measurements. The Whisker documentation and a possible future \textit{Getting-Started} guide have to ensure developers use those methods, instead of directly accessing JavaScript's Date objects.
  \item The \texttt{1000 / 60} frequency should be used by default, instead of the \texttt{1000 / 30} compatibility mode, as the first is the default for Scratch. Also, this increases the default execution speed by a factor of two.
  \item Allowing the test author to set the acceleration factor in the tests could be discussed. Extending the existing test driver with a setter method to allow this operation and a reset method to set the default value could be sufficient. Also, a specific method only affecting one test run, and one method to set the acceleration factor for the complete test-suite could be implemented. The \texttt{setup} method of the VMWrapper class is called for every individual test, therefore allows for such a granularity.
\end{itemize}




\section{Future Approaches for Whisker}

\subsection{Interacting with Scratch}
Several functionalities of Whisker depend on the current implementation of Scratch, for example, the input handling and coverage measurements. Also, it is unlikely that the Scratch source code will at once change a lot, at least without a major version release, even small changes could break Whisker. From a Whisker user's point of view, this is not a problem, as the Scratch version packaged with Whisker is defined in the project's \texttt{package.json} and the Whisker authors can ensure compatibility. However, for Whisker authors ensuring the compatibility and reacting to changes inside of the Scratch source code will be maintenance-intensive work. Therefore reducing dependencies on the Scratch source code's stability should be a goal for Whisker's future work.

One way to reduce dependencies could be to use Puppeteer to interact with the Scratch canvas, for example, to handle input events, like generating random input. Reading from the canvas could further be possible also, the author of this thesis did not find information about reading canvas information directly - but analyzing image data captured from a canvas element might be a workaround. Instead of calling methods exposed by the Scratch VM the significant advantage of this approach is that the methods of the Scratch VM can be changed upstream, without breaking at least the IO part of Whisker. The only official and stable interface Scratch allows users to interact with is the canvas element, therefore only or mostly using this element for (integration) testing should be the least maintaining intensive way.

Also, the Puppeteer based approach might reduce maintaining, reading, and understanding the Scratch VM's internal state is the only possible way for the coverage generation. Additionally, such a refactoring would be quite a rework of Whisker. Such an approach may be considered in case a new major Scratch version is released, and a Whisker rework is unavoidable.

\subsection{Automatically finding stable acceleration options}
The evaluation data showed that using acceleration combinations with high levels of parallelization and increased frequencies can also increase the failure rate of tests. In typical testing use cases, this can only be avoided by test-suite authors and users, who correctly estimate the acceleration options to be used based on their experience with the hardware they are using. In the context of search-based optimizations or debugging support, which could be future use cases for Whisker, the Servant could be enhanced to detect stable acceleration options based on some test runs automatically. Such an auto-acceleration feature based on several test runs would create overhead. However, when many runs have to be used to gather data, those additional runs might be negligible.

A simple approach could be an initial accelerated run with an acceleration factor of 10 and to reduce or increase the acceleration factor based on if tests fail or not. Those reduce or increase steps could also be done as soon as a failure occurs, to avoid waiting for the rest of the test-suite, when one can already be sure that the chosen acceleration options are not optimal.


\subsection{Test Prioritization}
Test Prioritization, as described in the chapter \textit{Related Work} by Elbaum et al., might increase usability and reduce test execution duration.
